function [solution,numiters] = task53(calcfanddfdx,x0,tol,maxit)

if nargin < 4
    maxit = 1000;
end
if nargin < 3
    tol = 1e-6;
end
if nargin < 2
    x0 = 0;
end
if nargin < 1
    disp('You need to supply at least the function argument')
    return
end    

if nargin < 4
    disp(sprintf('Had to use %d default value(s)',4-nargin))
end

printwelcome();

iterations = 0;

x = x0;
while 1    
    x_old = x;
    
    [fx,dfdx] = calcfanddfdx(x);
    
    x = x - fx/dfdx;
    iterations = iterations + 1;
    difference = abs(x - x_old);
    
    if ((difference < tol) | (iterations == maxit))
      break;
    end
end

numiters = iterations;
solution = x;

function printwelcome()
disp('Welcome to this wonderful program')